        /// <(#)>  DataFileContent; class to express TimeControl </(#)>
        /// Tested and modified by Naoto Ohshima. Date:2007/07/30 14:14:38
        ///                                       Last update:2007/08/04 15:00:11      
/// <summary> 
/// </summary>
using System;
using OhymosNet;

namespace OhymosNet
{
	
	
	/// <summary>
	/// f[^t@C̓e\񋓑̂łB<p/>
	/// 
	/// 񋓎q͌^ɈSȒ萔ɂȂ܂B<p/>
    /// DataFileContent;<p/>
    /// DataFileContent enum type. <p/>
    /// </summary>
    /// <remarks>
    /// 񋓎q̊Tv͈ȉ̒ʂłB
	/// <ul>
	/// <dt> PARSET :</dt>
	/// <dd>  f[^t@CɃp^L^ĂB</dd>
	/// <dt> INITIAL :</dt>
	/// <dd>  f[^t@CɏԗʂL^ĂB</dd>
	/// <dt> SDPDATA :</dt>
	/// <dd>  f[^t@CɑM[qɎcĂf[^L^ĂB</dd>
	/// </ul>
	/// <p/>
	/// 
	/// <a href="OhymosNet.OhTotalSystem.deliverDataString.html">OhTotalSystem.deliverDataString(String, DataFileContent)</a> 
	/// gpĂ܂B
	/// 
	/// Definition of DataFileContent<p/>
	/// <dl>
	/// <dt>PARSET:</dt>  <dd>Parameter values are contained in the file.</dd>
    /// <dt>INITIAL:</dt> <dd>Initial state values are contained in the file.</dd>
    /// <dt>SDPDATA:</dt> <dd>Send port datapacks are contained in the file.</dd>
	/// </dl>
    /// </remarks>
	[Serializable]
    public enum DataFileContent
    {
        /// <summary> <japanese>
        /// f[^t@CɃp^L^Ă邱Ƃ\^ɈSȒ萔łB
        /// </japanese>
        /// <p/>
        /// PARSET: <br/>
        /// Parameter values are contained in the file.
        /// 
        /// </summary>
        PARSET,

        /// <summary> <japanese>
        /// f[^t@CɏԗʂL^Ă邱Ƃ\^ɈSȒ萔łB
        /// </japanese>
        /// <p/>
        /// INITIAL: <br/>
        /// Initial state values are contained in the file.
        /// 
        /// </summary>
        INITIAL,

        /// <summary> <japanese>
        /// f[^t@CɑM[qɎcĂf[^L^Ă邱Ƃ\^ɈSȒ萔łB
        /// </japanese>
        /// 
        /// <p/>
        /// SDPDATA: <br/>
        /// Send port datapacks are contained in the file.
        /// 
        /// </summary>
        SDPDATA,
    }
}