using System;
namespace OhymosNet
{
	
	/// <summary>
    /// <a href = "OhymosNet.OhTime.html">OhTime</a>IuWFNgɃANZXC^[tF[XłB<p/>
    /// Interface to access an <a href = "OhymosNet.OhTime.html">OhTime</a> object.
    /// <p/>
    /// </summary>
    /// <remarks>
    /// ԂύXȂ\bh܂Ƃ߂Ă܂B
    /// Interface to access an OhTime object which does not change
    /// the state of the object.
    /// </remarks>
	public interface IOhTimeImmutable
	{
		/// <summary> 
        /// b̐擾܂B<p/>
        /// Gets the integer part of time which is expressed in
		/// seconds.
		/// 
		/// </summary>
		/// <returns> a <var>long</var> value
		/// </returns>
        long Sec { get;}
		
		/// <summary>
        /// b̒[擾܂B<p/>
        /// Gets the fractional part of time which is expressed in
		/// seconds.
		/// 
		/// </summary>
		/// <returns> a <var>double</var> value
		/// </returns>
        double Frac { get; }
		
		/// <summary> 
        /// b擾܂B
        /// Ȃ킿A_sec  _frac𑫂킹̂擾܂B<p/>
        /// _sec + _frac.
		/// 
		/// </summary>
		/// <returns> a <var>double</var> value
		/// </returns>
		double toDouble();
		
		/// <summary> 
        /// IuWFNg̃N[Ԃ܂B
        /// Returns a clone of this object
		/// 
		/// </summary>
		/// <returns> an <var>Object</var> value
		/// </returns>
		//Object clone();
		
		/// <summary> 
        /// ̃IuWFNgƓǂ肵܂B
        /// trueAȂfalseԂ܂B<p/>
        /// Returns the boolean variable which shows whether this
		/// object is equal to the argument <b>anObj</b> or not.
		/// 
		/// </summary>
		/// <param name="anObj">an <var>Object</var> value
		/// </param>
		/// <returns> a <var>boolean</var> value
		/// </returns>
		bool Equals(Object anObj);
		
		/// <summary> 
        /// ݂ IOhTimeImmutable IuWFNg <b>anObj</b> \킷
        /// Ƃ̎ԍ <b>anEps</b> 菬 (true)Ał
        ///  (false) Ԃ܂B<p/>
        /// 
        /// Check whether the time difference between the current
		/// IOhTimeImmutable object and <b>anObj</b> is less than
		/// <b>anEps</b>.
		/// </summary>
		/// <param name="anObj">an <var>Object</var> value
		/// </param>
		/// <param name="anEps">a <var>double</var> value
		/// </param>
		/// <returns> a <var>boolean</var> value
		/// </returns>
		bool equals(Object anObj, double anEps);
	}
}