/// <(#)>  OhArrayList; </(#)>
/// Tested and modified by Naoto Ohshima. Date:2007/07/19 18:03:40 
/// <summary> 
/// </summary>
using System;
using System.Collections;
using OhymosNet;


namespace OhymosNet
{
	
	/// <summary> <japanese>
	/// NX ArrayList pč쐬z񃊃XgNXłB
	/// </japanese>
	/// 
	/// </summary>
    /// <remarks>
    /// OhArrayList͉ϒ̔złBvf̒ǉA폜ȂǂeՂɂł܂B
    /// vff[q̓o^A܂f[^pbNz̍쐬Ɏgp܂B
    /// 
    /// </remarks>
	[Serializable]
	public class OhArrayList:ArrayList
	{


        // @begin{field} -------------------------------------------------------

        /// <summary> <japanese>
        /// CfbNXłB
        /// </japanese>
        /// 
        /// </summary>
        protected internal int _startIndex;

        // @end{field} ---------------------------------------------------------


        // @begin{constructor} -------------------------------------------------

        /// <summary> <japanese>
        /// _startIndex  0 ̋̃Xg쐬܂B
        /// </japanese>
        /// 
        /// </summary>
        public OhArrayList()
        {
            _startIndex = 0;
        }

        // @end{constructor} ---------------------------------------------------
		


        // @begin{property}---------------------------------------------------

        /// <summary> <japanese>
        /// _startIndex ̎擾Eݒs܂B
        /// </japanese>
        /// 
        /// </summary>
        
        virtual public int StartIndex
        {
            get
            {
                return _startIndex;
            }
            set
            {
                _startIndex = value;
            }
        }

        /// <summary> <japanese>
        /// Xg̍Ō̗vfԂ܂B
        /// </japanese>
        /// 
        /// </summary>
        /// <returns> an <code>Object</code> value
        /// </returns>
        virtual public Object LastElement
        {
            get
            {
                return this[Count - 1];
            }
        }

        // @end{property}-----------------------------------------------------

       
		// @begin{methods} -----------------------------------------------------
		
		/// <summary> 
        /// z񃊃Xg̃CfbNXaFrom  aTo - 1 ܂ł̗vf폜܂B
        /// </summary>
        /// <remarks>
		/// ̃XgAaFrom Ŏn܂ aTo ̒OŏICfbNX(aTo - 1)ׂĂ̗vf폜܂B
		/// 㑱̗vf͍Ɉړ܂(CfbNXl)B
		/// ̌Ăяo OhArrayList  (toIndex - fromIndex) ̗vfZk܂B
		/// toIndex==fromIndex ̏ꍇÃIy[Vɂ͉e͂܂B
        /// </remarks>
		/// 
		/// 
		/// <param name="aFrom">an <code>int</code> value
		/// </param>
		/// <param name="aTo">an <code>int</code> value
		/// </param>
		public void  removeRange(int aFrom, int aTo)
		{
			base.RemoveRange(aFrom, aTo - aFrom);
		}
		
		
        /// <summary> 
        /// tŁAz񃊃Xg̃CfbNX 0  aIndex - 1 ܂ł̗vf폜܂B
        /// </summary>
        /// <remarks>
        /// 0  <b>aIndex</b> - 1 ͈̔͂̃CfbNX
        /// <b>aIndex</b>̗vf폜悤Ƃ܂B<b>aIndex</b> 
        /// <b>_startIndex</b> 菬ꍇ́A܂B
        /// XgɊi[Ăvf 12 ȏŁA<b>size()</b>/4
        /// 菬ꍇ́A폜𗯕ۂāA<b>_startIndex</b> 
        /// <b>aIndex</b> ɕύX܂BȊȌꍇ́AۂɁA
        /// 0  <b>aIndex</b> - 1 ͈̔͂̃CfbNXv
        /// f폜A<b>_startIndex</b>  0 ɐݒ肵܂B<p/>
        ///
        /// Tries to remove the first part of the elements of this list
        /// whose index ranges from 0 to <b>aIndex</b> - 1.  If
        /// <b>aIndex</b> is less than or equal to
        /// <b>_startIndex</b>, no elements are removed. If <b>size()</b>
        /// is greater than or equal to 12 and <b>aIndex</b> &lt;
        /// <b>size()</b>/4, <b>_startIndex</b> is updated to <b>aIndex</b>.
        /// Otherwise, the elements with indexes from from 0 to
        /// <b>aIndex</b> - 1 are actually removed and
        /// <b>_startIndex</b> is updated to 0.
        /// 
        /// </remarks>
        ///  
        /// <param name="aIndex">an <code>int</code> value
        /// </param>
        public virtual void removeHeadRange(int aIndex)
        {
            if (aIndex < _startIndex)
            {
                return;
            }
            else if (Count >= 12 && aIndex < (Count / 4))
            {
                _startIndex = aIndex;
                return;
            }
            else
            {
                removeRange(0, aIndex);
                _startIndex = 0;
            }
        }
		
        /// <summary>
        /// {NXArrayList̃I[o[Ch\bhłB
        /// OhArrayList ̖ɃIuWFNgǉ܂B
        /// </summary>
        /// <param name="o">ɒǉobjectl</param>
        /// <returns>oǉꂽʒu System.Collections.ArrayList CfbNX</returns>
        public override int Add(object o)
        {
            return base.Add(o);
        }

		// @end{methods} --------------------------------------------------------
	} // OhArrayList
}