/// <(#)>  DataConnectionType; class to express DataConnectionType. </(#)>
/// Tested and modified by Naoto Ohshima. Date:2007/07/20 20:07:06
/// Last update: 2007/08/02 19:54:14   
/// <summary> 
/// </summary>
using System;
using OhymosNet;

namespace OhymosNet
{
	/// <summary> 
	/// f[^Ԍ^\񋓑̂łB
	/// 
	/// 񋓎q͌^ɈSȒ萔ƂȂ܂B
    /// 
	/// </summary>
	public enum DataConnectionType
    {
        /// <summary> <japanese>
        /// ܂Ńf[^Ԃ܂Bgp̂łʓIł傤B
        /// f[^Ԍ^Ɏw肵Ȃꍇ͂ BROKENLINE ɐݒ肳܂B
        /// </japanese>
        /// <p>
        /// BROKENLINE : The data are connected with broken line.
        /// </p>
        /// </summary>
        BROKENLINE = 0,

        /// <summary> <japanese>
        /// Xebvf[^łBA鎞ɂf[^ĺA̎܂ňlƂ܂B
        /// </japanese>
        /// <p>
        /// STEP: 
        /// The value is taken constant and equal to the current data value
        /// from the previous data time till the current time.
        /// </p></summary>
        STEP,

        /// <summary> <japanese>
        /// pXf[^łBA鎞Ǝ̎Ƃ̊Ԃ̒l 0 Ƃ܂B
        /// </japanese>
        /// <p>
        /// PULSE : The value between data times is taken to be zero.
        /// </p>
        /// 
        /// </summary>
        PULSE,

        /// <summary> <japanese>
        /// ԂłȂƂ\܂B
        /// </japanese>
        /// <p>
        /// NOINTP : No interpolation.
        /// </p>
        /// 
        /// </summary>
        NOINTP,
    }

 
}