/// <(#)>  OhInterface; base class for OHyMoS.NET interface. </(#)>
/// <summary> Modified and Tested by Naoto Ohshima. Date:2007/10/27 15:12:53
/// </summary>
using System;
using System.IO;
using System.Text;
using OhymosNet;

namespace OhymosNet
{
	
	/// <summary>
	/// OHyMoS.NET ̃C^[tFCX\NXłB
	/// </summary>
    /// <remarks>
    /// [UƂ̑ΘbƂŎgp܂B
    /// ͂ꂽԂ\bh
    /// <a href ="OhymosNet.OhInterface.getReply.html">getReply(string, string)</a>ƁA
    /// return͂҂\bh
    /// <a href ="OhymosNet.OhInterface.pause.html">pause(string)</a>
    /// 񋟂܂B
    /// 
    /// </remarks>
	public class OhInterface
	{
		
		/// <summary>
        /// ͂ꂽԂ܂BÓI\bhłB<p/>
        /// Gets reply.
        /// </summary>
        /// <remarks>
        /// 1̃̕bZ[WWo͂ɕ\A̓͂҂A
        /// 񂪓͂΁A̕Ԃ܂B
        /// 
        /// </remarks>
        /// <param name="aMessage">a <var>String</var> value<p/>
        /// \镶
		/// </param>
        /// <param name="aDefaultReply">a <var>String</var> value<p/>
		/// </param>
        /// <returns> a <var>String</var> value<p/>
        /// ͂ꂽ
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public static String getReply(String aMessage, String aDefaultReply)
		{
			
			Object obj = null;
			String rep = null;
			
            // GUI̕͏

            if (OhOption.Default.UseWinP)
            {
            }
            //; ------------------------------------------------------------- end WINDOWS.
            else
            {
				Console.Out.WriteLine(aMessage);
                Console.Out.Write(">");
				
				StreamReader isr = new StreamReader(Console.OpenStandardInput(), Encoding.Default);
				
				try
				{
					rep = isr.ReadLine();
                    Console.WriteLine();
				}
				catch (IOException e)
				{
					throw new OhError("Quit.");
				}
            }
			
			if (rep.Equals("^C"))
				throw new OhError("Quit.");
			
			return rep;
		}
		
		
		/// <summary>
        /// return Ԃ܂Ń|[Y܂B<p/>
        /// Pause.
        /// </summary>
        /// <remarks>
        /// P̃̕bZ[WWo͂ɕ\AreturnԂ܂Ń|[Y܂B 
        /// </remarks>
		/// <param name="aMessage">a <var>String</var> value
		/// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public static void  pause(String aMessage)
		{
			
            if (OhOption.Default.UseWinP)
            {
            }
            //; -------------------------------------------------------------- end WINDOWS.
            else
            {
				Console.Out.WriteLine(aMessage);
				Console.Out.WriteLine("Hit return key: ");
				
				StreamReader isr = new StreamReader(Console.OpenStandardInput(), Encoding.Default);
				
				try
				{
					String s = isr.ReadLine();
				}
				catch (IOException e)
				{
					throw new OhError("Quit.");
				}
            }
		}
	} // OhInterface
}