/// <(#)>  OperationFlag; class to express OperationFlag. </(#)>
/// <summary>                     Make "OperationFlag.java" from "ohelement.h" by Satoh.
/// Tested and Modified by Naoto Ohshima. Date: 2007/08/04 14:59:38
/// 
///  </summary>
using System;
using OhymosNet;
namespace OhymosNet
{
	
	
	/// <summary> 
	/// ƂɊւtO\񋓑̂łB<p/>
	/// 
	/// 񋓎q͌^ɈSȒ萔ɂȂ܂B<p/>
    /// OperationFlag;
    /// 
    /// OperationFlag class. <p/>
    /// </summary>
    /// <remarks>
    /// 񋓎q̊Tv͈ȉ̒ʂłB
	/// <ul>
	/// <dt> E_UNDONE :</dt>
	/// <dd>  Ƃ邱ƂłȂB</dd>
	/// <dt> E_DONE :</dt>
	/// <dd>  ƂsB</dd>
	/// <dt> E_ALREADY :</dt>
	/// <dd>  Ƃ͂łɎsς݂łB</dd>
	/// </ul>
	/// 
	/// R̌^́A
	/// <a href="OhymosNet.OhElement.doShareInfo.html">OhElement.doShareInfo()</a>,
	/// <a href="OhymosNet.OhElement.doInitialWork.html">OhElement.doInitialWork()</a> ȂǂŗpĂ܂B
	/// 
	/// <p/>
	/// <br/>
	/// <ul>
	/// <li> E_UNDONE  : Initial work could not be done.</li>
	/// <li> E_DONE    : Initial work was completed.</li>
	/// <li> E_ALREADY : Initial work had been done already.</li>
	/// </ul>
	/// 
    /// This type is used in <a href="OhymosNet.OhElement.doShareInfo.html">OhElement.doShareInfo()</a>,
    /// <a href="OhymosNet.OhElement.doInitialWork.html">OhElement.doInitialWork()</a>.
    /// </remarks>
	[Serializable]
    public enum OperationFlag
    {
        /// <summary> <japanese>
        /// Ƃ邱ƂłȂƂ\^ɈSȒ萔łB
        /// </japanese>
        /// <p>
        /// E_UNDONE: <br/>
        /// Initial work could not be done. </p>
        /// 
        /// </summary>
        E_UNDONE=0,

        /// <summary> <japanese>
        /// ƂsƂ\^ɈSȒ萔łB
        /// </japanese>
        /// <p>
        /// E_DONE: <p/>
        /// Initial work was completed. </p>
        /// 
        /// </summary>
        E_DONE,

        /// <summary> <japanese>
        /// Ƃ͂łɎsς݂łƂ\^ɈSȒ萔łB
        /// </japanese>
        /// <p>
        /// E_ALREADY: <p/>
        /// Initial work had been done already.
        /// </p>
        /// </summary>
        E_ALREADY,
    }
    /*
	[Serializable]
	public sealed class OperationFlag
	{
		// @begin {instance variable or static variable} -----------------------
		
		private static int nextOrdinal = 0;
		//UPGRADE_NOTE: final ́A'ordinal ' ̐錾폜܂B "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1003'"
		private int ordinal = nextOrdinal++;
		
		/// <summary> <japanese>
		/// Ƃ邱ƂłȂƂ\^ɈSȒ萔łB
		/// </japanese>
		/// <p>
		/// E_UNDONE: <br>
		/// Initial work could not be done. <p>
		/// 
		/// </summary>
		//UPGRADE_NOTE: final ́A'E_UNDONE ' ̐錾폜܂B "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1003'"
		public static readonly OperationFlag E_UNDONE = new OperationFlag();
		
		/// <summary> <japanese>
		/// ƂsƂ\^ɈSȒ萔łB
		/// </japanese>
		/// <p>
		/// E_DONE: <p>
		/// Initial work was completed. <p>
		/// 
		/// </summary>
		//UPGRADE_NOTE: final ́A'E_DONE ' ̐錾폜܂B "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1003'"
		public static readonly OperationFlag E_DONE = new OperationFlag();
		
		/// <summary> <japanese>
		/// Ƃ͂łɎsς݂łƂ\^ɈSȒ萔łB
		/// </japanese>
		/// <p>
		/// E_ALREADY: <p>
		/// Initial work had been done already.
		/// 
		/// </summary>
		//UPGRADE_NOTE: final ́A'E_ALREADY ' ̐錾폜܂B "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1003'"
		public static readonly OperationFlag E_ALREADY = new OperationFlag();
		
		//UPGRADE_NOTE: final ́A'PRIVATE_VALUES ' ̐錾폜܂B "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1003'"
		private static readonly OperationFlag[] PRIVATE_VALUES = new OperationFlag[]{E_UNDONE, E_DONE, E_ALREADY};
		
		// @end {instance variable or static variable} -------------------------
		
		
		// @begin {constructors} -----------------------------------------------
		
		private OperationFlag()
		{
		}
		
		// @end {constructors} -------------------------------------------------
		
		
		// @begin {methods} ----------------------------------------------------
		
		private Object readResolve()
		{
			return PRIVATE_VALUES[ordinal];
		}
		
		// @end {methods} ------------------------------------------------------
	} // OperationFlag
    */
}