/// <(#)>  TimeControl; class to express TimeControl. </(#)>
/// <summary>                   Make "TimeControl.java" from "ohoption.h" by Satoh.
/// Tested and modified by Naoto Ohshima. Date: 2007/08/04 15:47:48
/// </summary>
using System;
using OhymosNet;
namespace OhymosNet
{
	
	
	/// <summary>
	/// ԖڕW𒴂ČvZ邩ۂ킷񋓑̂łB<p/>
	/// 
	/// 񋓎q͌^ɈSȒ萔ɂȂ܂B<p/>
    /// </summary>
    /// <remarks>
	/// <ul>
	/// <dt> GO_BEYOND_TERMINAL_TIME :</dt>
	/// <dd>  ԖڕW𒴂ČvZB</dd>
	/// <dt> DO_NOT_GO_BEYOND_TERMINAL_TIME :</dt>
	/// <dd>  ԖڕW𒴂ɌvZB</dd>
	/// </ul>
	/// 
	/// ԖڕWƂ́A
	/// ڕW <a href="OhTotalSystem.html#_terminalTime">OhTotalSystem._terminalTime</a> ȑO
	/// iʂȏꍇƂāA<a href="OhTotalSystem.html#_terminalTime">OhTotalSystem._terminalTime</a> 
	/// vĂ悢j̎ŁASĂ̗vf͂̎𒴂邱ƂڕWɌvZi߂ĂƂłB<p/>
	/// 
	/// ԖڕẂA
	/// <a href="OhTotalSystem.html">OhTotalSystem</a> ̃oϐ
	/// <a href="OhTotalSystem.html#_mediumTermTargetTime">OhTotalSystem._mediumTermTargetTime</a> Ƃ
	/// ^Ă܂B<p/>
	/// 
	/// <a href="OhTotalSystem.html#_terminalTime">OhTotalSystem._terminalTime</a> ȑOɒԖڕWݒ肵A
	/// SĂ̗vf͒ԖڕW܂ŌvZΐ摖肹A
	/// ̗vf̌vZ҂悤ɂ̂悤ɂĂ܂B<p/>
	/// 
	/// ܂AԖڕW̓ɂāAŠn̗vfׂĂŌvZi߂lɂȂłȂA
	/// ʂ̍팸}܂B
	/// ܂AvfXgbNĂ˂΂ȂȂf[^pbŃA
	/// ԖڕW玟̒ԖڕW܂ł̎ԕł悭A
	/// vZԂɂĎgpʂϓ邱ƂȂȂƍl܂B
	/// <p/>
	/// TimeControl;
	/// 
	/// TimeControl class. <p/>
	/// 
	/// Definition of TimeControl. <p/>
    ///  
	/// <ul>
	/// <li> GO_BEYOND_TERMINAL_TIME        : Can go beyond the teminal time</li>
	/// <li> DO_NOT_GO_BEYOND_TERMINAL_TIME : Cannot go beyond the terminal time</li>
	/// </ul>
    /// </remarks>
	/// <author>  <a href="mailto:satoh@wr.kuciv.kyoto-u.ac.jp">satoh</a>
	/// </author>
	/// <version>  $Revision: 1.9 $ $Date: 2004/02/10 14:19:13 $
	/// </version>
    /// 

    [Serializable]
    public enum TimeControl
    {
        /// <summary> <japanese>
        /// ԖڕW𒴂ČvZ邱Ƃ\^ɈSȒ萔łB
        /// </japanese>
        /// <p/>
        /// GoBeyondTerminalTime: <br/>
        /// Can go beyond the teminal time
        /// 
        /// </summary>
        GO_BEYOND_TERMINAL_TIME,

        /// <summary> <japanese>
        /// ԖڕW𒴂ɌvZ邱Ƃ\^ɈSȒ萔łB
        /// </japanese>
        /// <p/>
        /// DoNotGoBeyondTerminalTime: <p/>
        /// Cannot go beyond the terminal time
        /// 
        /// </summary>
        DO_NOT_GO_BEYOND_TERMINAL_TIME
    }
    /*
	[Serializable]
	public sealed class TimeControl
	{
		// @begin {instance variable or static variable} -----------------------
		
		private static int nextOrdinal = 0;
		//UPGRADE_NOTE: final ́A'ordinal ' ̐錾폜܂B "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1003'"
		private int ordinal = nextOrdinal++;
		
		/// <summary> <japanese>
		/// ԖڕW𒴂ČvZ邱Ƃ\^ɈSȒ萔łB
		/// </japanese>
		/// <p/>
		/// GoBeyondTerminalTime: <br/>
		/// Can go beyond the teminal time
		/// 
		/// </summary>
		//UPGRADE_NOTE: final ́A'GO_BEYOND_TERMINAL_TIME ' ̐錾폜܂B "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1003'"
		public static readonly TimeControl GO_BEYOND_TERMINAL_TIME = new TimeControl();
		
		/// <summary> <japanese>
		/// ԖڕW𒴂ɌvZ邱Ƃ\^ɈSȒ萔łB
		/// </japanese>
		/// <p/>
		/// DoNotGoBeyondTerminalTime: <p/>
		/// Cannot go beyond the terminal time
		/// 
		/// </summary>
		//UPGRADE_NOTE: final ́A'DO_NOT_GO_BEYOND_TERMINAL_TIME ' ̐錾폜܂B "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1003'"
		public static readonly TimeControl DO_NOT_GO_BEYOND_TERMINAL_TIME = new TimeControl();
		
		//UPGRADE_NOTE: final ́A'PRIVATE_VALUES ' ̐錾폜܂B "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1003'"
		private static readonly TimeControl[] PRIVATE_VALUES = new TimeControl[]{GO_BEYOND_TERMINAL_TIME, DO_NOT_GO_BEYOND_TERMINAL_TIME};
		
		// @end {instance variable or static variable} -------------------------
		
		
		// @begin {constructors} -----------------------------------------------
		
		/// <summary> Creates a new default <code>TimeControl</code> instance.
		/// 
		/// </summary>
		public private TimeControl()
		{
		}
		
		// @end {constructors} -------------------------------------------------
		
		
		// @begin {methods} ----------------------------------------------------
		
		private Object readResolve()
		{
			return PRIVATE_VALUES[ordinal];
		}

      
		// @end {methods} ------------------------------------------------------
	} // TimeControl
    */
}